// Created by John Liaperdos - April 2015

var entry_mode=0; // 0 -> zero, 1-> pole
var add_delete_mode=1; // 0 -> delete, 1-> add
var bode_total = []; 
var selected_partial_plots=[];
var partial_plot_colors=['red','green','orange','yellow','brown'];
var y_scale_factor=1;

var bode_partial = new Array(5); //[i][j][k] -> [root/pole id, 0/1 (root/pole), data_points]
for (var i = 0; i < 5; i++) 
{
	bode_partial[i] = new Array(2);
	for (var j = 0; j < 2; j++)
	{
		bode_partial[i][j] = new Array(331);
	}
}

var base_knee_point=331/6;
var plot_area_aspect_ratio = 98/331;

for (i = 0; i < 331; i++) {
    bode_total[i]=0;
}

for (i = 0; i < 5; i++) {
	for (j = 0; j < 2; j++) {
		for (k = 0; k < 331; k++) {
			if(k<=(i+1)*base_knee_point)
			{
				bode_partial[i][j][k]=0;
			}
			else
			{
				y_sign=1;
				if(j==1)
				{
					y_sign=-1;
				}
				bode_partial[i][j][k]=y_sign*((k-(i+1)*base_knee_point)*plot_area_aspect_ratio);
			}
			
		}
	}
}

function toggleEntryMode(){
	if (entry_mode==1)
	{
		entry_mode=0;
		document.getElementById('entry_mode_text').textContent='z';
	}
	else
	{
		entry_mode=1;
		document.getElementById('entry_mode_text').textContent='p';
	}
}

function toggleAddDeleteMode(){
	if (add_delete_mode==1)
	{
		add_delete_mode=0;
		document.getElementById('add_delete_text').textContent='-';
	}
	else
	{
		add_delete_mode=1;
		document.getElementById('add_delete_text').textContent='+';
	}
}

function omegaToScreen(value){ //value: ω (rad/s)
	value_transformed=2+(Math.log(value)/ Math.LN10);
	value_transformed=65+(396-65)*value_transformed/6;		
	return value_transformed;
}

function transformCoordinates(value,direction){ //value: screen points (x-axis:0 to 330) or magnitude (dB, y-axis)
	if(direction=='x')
	{
		value_transformed=65+(396-65)*value/6;		
	}
	else
	{
		value_transformed=124-(124-26)*value/120;
	};	
	return value_transformed;
}

function drawTotal(){ 
	var total_group = document.getElementById('total_bode_plot');
	// clear content
		while (total_group.hasChildNodes()) {
			total_group.removeChild(total_group.lastChild);
		}
	// create new line
		findTotalPlotPoints();
		for (var i = 0; i < 330; i++) {
			var line_out = document.createElementNS("http://www.w3.org/2000/svg", "line");
			line_out.setAttribute('x1', i+65);
			line_out.setAttribute('x2', i+66);
			line_out.setAttribute('y1', 124-bode_total[i]);
			line_out.setAttribute('y2', 124-bode_total[i+1]);
			line_out.setAttribute('style', "stroke:magenta;stroke-width:2.5");
			total_group.appendChild(line_out);
		}
}

function drawPartial(){ 
	var partial_group = document.getElementById('partial_bode_plots');
	// clear content
		while (partial_group.hasChildNodes()) {
			partial_group.removeChild(partial_group.lastChild);
		}
	// create new lines
		for (var j = 0; j < selected_partial_plots.length; j++) {
			for (var i = 0; i < 330; i++) {
				var line_out = document.createElementNS("http://www.w3.org/2000/svg", "line");
				line_out.setAttribute('x1', i+65);
				line_out.setAttribute('x2', i+66);
				current_zero_pole_id=mapZeroPoleIds(selected_partial_plots[j])[0];
				current_zero_pole_type=mapZeroPoleIds(selected_partial_plots[j])[1];
				line_out.setAttribute('y1', 124-(y_scale_factor*bode_partial[current_zero_pole_id][current_zero_pole_type][i]));
				line_out.setAttribute('y2', 124-(y_scale_factor*bode_partial[current_zero_pole_id][current_zero_pole_type][i+1]));
				line_out.setAttribute('style', "stroke:"+partial_plot_colors[current_zero_pole_id]+";stroke-width:1.5");
				partial_group.appendChild(line_out);
			}
		}
}

function selectZeroPole(zeroPole_id){ 
	// check if already selected
		for (var i = 0; i < selected_partial_plots.length; i++) {
			if(selected_partial_plots[i]==zeroPole_id) return;
		}
	// add to selected
		selected_partial_plots[selected_partial_plots.length]=zeroPole_id;
}

function unselectZeroPole(zeroPole_id){ 
	// remove from selected	
		var tmp_array=[];
		for (var i = 0; i < selected_partial_plots.length; i++) {
			if(selected_partial_plots[i]!=zeroPole_id)
			{
				tmp_array.push(selected_partial_plots[i]);
			}
		}
		selected_partial_plots=tmp_array;	
}

function mapZeroPoleIds(zeroPole_id){ 
	if (zeroPole_id==1) return [0,0];
	if (zeroPole_id==2) return [0,1];
	if (zeroPole_id==3) return [1,0];
	if (zeroPole_id==4) return [1,1];
	if (zeroPole_id==5) return [2,0];
	if (zeroPole_id==6) return [2,1];
	if (zeroPole_id==7) return [3,0];
	if (zeroPole_id==8) return [3,1];
	if (zeroPole_id==9) return [4,0];
	if (zeroPole_id==10) return [4,1];
}

function findTotalPlotPoints(){ 
	for (i = 0; i < 331; i++) {
		bode_total[i]=0;
	}
	for (var i = 0; i < selected_partial_plots.length; i++) {
		for (j = 0; j < 331; j++) {			
			current_zero_pole_id=mapZeroPoleIds(selected_partial_plots[i])[0];
			current_zero_pole_type=mapZeroPoleIds(selected_partial_plots[i])[1];
			bode_total[j]=bode_total[j]+bode_partial[current_zero_pole_id][current_zero_pole_type][j];			
		}
	}
	// calculate y axis scale factor
		// find absolute total y value
			max_val=Math.abs(bode_total[330]);
		// find scale factor (y+ axis has a height of 98)
			inverse_y_scale_factor=Math.ceil(Math.max(1,max_val/98));
			y_scale_factor=1/inverse_y_scale_factor;
		// scale points
			for (i = 0; i < 331; i++) {	
				bode_total[i]=bode_total[i]*y_scale_factor;
			}		
}

function respondToClick(zero_pole_id){
	xform_zero_pole_id=2*zero_pole_id+entry_mode+1;
	if(add_delete_mode==1)//add
	{		
		selectZeroPole(xform_zero_pole_id);
	}
	else
	{
		unselectZeroPole(xform_zero_pole_id);	
	};
	drawTotal();
	drawPartial();
	updateYaxisTicks();
}

function resetPlots(){
	y_scale_factor=1;
	selected_partial_plots=[];
	drawTotal();
	drawPartial();
	updateYaxisTicks();
}

function updateYaxisTicks(){
	document.getElementById('pos_tick_01').textContent=40/y_scale_factor;
	document.getElementById('neg_tick_01').textContent=-40/y_scale_factor;
	document.getElementById('pos_tick_02').textContent=80/y_scale_factor;
	document.getElementById('neg_tick_02').textContent=-80/y_scale_factor;
	document.getElementById('pos_tick_03').textContent=120/y_scale_factor;
	document.getElementById('neg_tick_03').textContent=-120/y_scale_factor;	
}




